<template>
  <main class="form-signin">
    <form @submit.prevent="submit">
      <h1 class="d-flex justify-content-center h3 mb-3 fw-normal">
        Welcome back!
      </h1>

      <input
        v-model="data.email"
        type="email"
        class="form-control"
        placeholder="Email"
        required
      />

      <input
        v-model="data.password"
        type="password"
        class="form-control"
        placeholder="Password"
        required
      />

      <button class="w-100 btn btn-lg btn-primary" type="submit">
        Sign in
      </button>
    </form>

    <div class="alert alert-danger my-3" role="alert" v-if="data.alertMessage">
      {{ data.alertMessage }}
    </div>

    <div class="container my-2 d-flex justify-content-center">
      Don't have an account?&nbsp;
      <router-link to="/">Register</router-link>
    </div>
  </main>
</template>

<script>
import { reactive } from "vue";
import { useRouter } from "vue-router";
import { useStore } from "vuex";

export default {
  name: "Login",
  setup() {
    const router = useRouter();
    const store = useStore();

    const data = reactive({
      email: "",
      password: "",
      alertMessage: "",
    });

    store.commit("setAuth", { auth: false });

    const submit = async () => {
      const response = await fetch("api/login", {
        method: "POST",
        headers: { "Content-Type": "application/json" },
        credentials: "include",
        body: JSON.stringify(data),
      });

      if (response.status == 200) {
        await router.push("/my-profile");
      } else if (response.status == 400) {
        data.alertMessage = "Wrong credentials";
      } else if (response.status == 404) {
        data.alertMessage = "There are no account with this email";
      } else {
        data.alertMessage = "Network Error";
      }
    };

    return {
      data,
      submit,
    };
  },
};
</script>
